/* This is a simple demo of a Rexx (modelled after the JavaScript) script that
   uses the Java URL class to download some content from some URL. rgf, 2003-01-27, 2003-05-10 */

   /* use the Java URL class to read data from a WWW server */
URL_ADDR = "http://www.RexxLA.org/";

say "connecting to:" URL_ADDR
url=.url~new(URL_ADDR)    -- create a URL instance

   /* get the content, a <sun.net.www.http.KeepAliveStream> a subclass of: <sun.net.www.MeteredStream>, a subclass of: <java.io.FilterInputStream> */
content = url~getContent                  /* get the content object  */
say "Bytes available:" content~available  /* get # of bytes          */
say "Downloading .. "
ch=""
do until ch=-1                            /* read the content */
   ch=content~read                        /* returns an Integer value representing a Byte or -1 */
   if ch>=0 then call charout , ch~d2c    /* turn Byte integer value into character */
end

::requires BSF.CLS    -- Object Rexx wrapper classes

::class URL subclass BSF      -- now we can refer to that Java class as ".url" in Object Rexx
::method init           -- initialize
  self~init:super("java.net.URL", arg(1, "array")) -- forward to superclass
  return result
